<!DOCTYPE html>
<html lang="en"><head>
  <!-- Google tag (gtag.js) -->
  <script async src="https://www.googletagmanager.com/gtag/js?id=G-3SVS4XQ47V"></script>
  <script>
    window.dataLayer = window.dataLayer || [];
    function gtag(){dataLayer.push(arguments);}
    gtag('js', new Date());
  
    gtag('config', 'G-3SVS4XQ47V');
  </script>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta charset="utf-8">
  <meta name="author" content="Jim Hefferon">
  <meta name="copyright" content="Contents of this HTML page and its CSS is CCSA 4.0.">
  <link rel="canonical" href="https://hefferon.net/computation/">
  <meta property="og:locale" content="en_US">
  <meta property="og:type" content="website">
  <meta property="og:title" content="Free Theory of Computation text from Jim Hefferon">
  <meta property="og:description" content="Free Theory of Comptation Text, from Jim Hefferon">
  <meta property="og:url" content="https://hefferon.net/computation">
  <meta property="og:site_name" content="Free math texts">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Literata">
  <link rel="stylesheet" href="../hefferon.css">
  <title>Free Theory of Computation textbook: Contents</title>
</head>

<body>
  <div id="container">
    <div id="header">
      <p>
	<i>Theory of Computation:</i> Contents
      </p>
    </div>
    <div id="content">
      <div id="innercontent">
	<p>
	  <a href="https://joshua.smcvt.edu/computation/book.pdf"><i>Theory of Computation</i></a> by Jim Hefferon,
	  along with its companion
	  <a href="https://joshua.smcvt.edu/computation/answers.pdf">answers to exercises</a>, 
	  is a text for a one semester
	  first undergraduate Computer Science theory course.
	  It is Free.
	  Use it as the main book, as a supplement, or for independent study.
	</p>

	<h3>
	  Table of Contents
	</h3>

        <p>This shows the chapters and sections.
	  For more, see
	  <a href="/computation/">the description</a>
	  or
	  <a href="https://jheffero.w3.uvm.edu/computation/book.pdf">the text</a>.
	  </p>
	
	<ul class="nobullet">
	  <li><span class="listitem">Mechanical Computation</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Turing machines</li>
	  <li>Church's Thesis</li>
	  <li>Recursion</li>
	  <li>General Recursion</li>
	  <li>Topics: Turing machine simulator,
	    Hardware,
	    Game of Life,
	    Ackermann's function is not primitive recursive,
	    LOOP programs
	  </li>
	</ol>
	  
	<ul class="nobullet">
	  <li><span class="listitem">Background</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Infinity</li>
	  <li>Cantor's correspondence</li>
	  <li>Diagonalization</li>
	  <li>Universality</li>
	  <li>Halting problem</li>
	  <li>Rice's theorem</li>
	  <li>Computably enumerable sets</li>
	  <li>Oracles</li>
	  <li>Fixed point theorem</li>
	  <li>Topics: Hilbert's hotel, Halting problem in wider culture,
	    Self reproduction, Busy beaver</li>
	</ol>
	
	<ul class="nobullet">
	  <li><span class="listitem">Languages</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Languages</li>
	  <li>Grammars</li>
	  <li>Graphs</li>
	  <li>Topics: BNF, Tree traversal</li>
	</ol>
	  
	<ul class="nobullet">
	  <li><span class="listitem">Automata</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Finite state machines</li>
	  <li>Nondeterminism</li>
	  <li>Regular expressions</li>
	  <li>Regular languages</li>
	  <li>Non-regular languages</li>
	  <li>Pushdown machines</li>
	  <li>Topics: Regular expressions in the wild,
	    Myhill-Nerode theorem,
	    Minimization</li>
	</ol>
	  
	<ul class="nobullet">
	  <li><span class="listitem">Computational complexity</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Big <i>O</i></li>
	  <li>Problem miscellany</li>
	  <li>Problems, algorithms, and programs</li>
	  <li><i>P</i></li>
	  <li><i>NP</i></li>
	  <li>Polytime reduction</li>
	  <li><i>NP</i> completeness</li>
	  <li>Other classes</li>
	  <li>Topic: RSA encryption, Good-enoughness, SAT solvers, Bounded Halting problem</li>
	</ol>
	  
	<ul class="nobullet">
	  <li><span class="listitem">Back matter</span>
          </li>
	</ul>

        <ol class="sections">
	  <li>Review of strings</li>
	  <li>Review of functions</li>
	  <li>Review of propositional logic</li>
	  <li>Supplemental notes</li>
	  <li>Bibliography</li>
	  <li>Index</li>
	</ol>
      </div>
    </div>
    <div id="navbar">
      <div id="innernavbar">
	<h3>
	  More on <i>Theory of Computation</i>
	</h3>
	<ul>
	  <li><a href="/computation/">Description</a>
	    of the main features.</li>
	  <li><a href="/computation/slides.html">Slides</a>
	    for classroom projection.</li>
	  <li><a href="/source.html">License and source</a>.</li>
	  <li><a href="/help.html">Help out</a>.
	    Donate a little or make a report.</li>
	</ul>
	<h3>
	  You may also like ... 
	</h3>
	<ul>
	  <li><a href="linearalgebra/"><i>Linear Algebra</i></a>,
	      a popular undergraduate text.</li>
	  <li><a href="/proofs/"><i>Introduction to Proofs</i></a>,
	      for an Inquiry-Based course.</li>
	  <li><a href="/other/">More</a>,
	      including programs and documents.</li>
	  <li><a href="/jimhefferon.html">About me</a>.</li>
	  <li><a href="/">This site's home page</a>.</li>
	</ul>
      </div>
    </div>
    <div id="footer">
      <a id="contact" href="/jimhefferon.html">Contact me</a>
    </div>


</div></body></html>
